<?php

if (!defined('ABSPATH')) {
    exit;
}

// add_action('woocommerce_thankyou','roadcube_after_checkout_transaction');
// add_action('save_post_shop_order','roadcube_after_checkout_transaction');
// add_action('wp_insert_post','roadcube_after_checkout_transaction');
// function roadcube_after_checkout_transaction( $order_id ){
//     $post = get_post( $order_id );
//     if( $post->post_type != 'shop_order' ) return;
//     if( get_post_meta($order_id,'roadcube_new_transaction',true) ) return;
//     $order = wc_get_order( $order_id );
//     $customer_id = $order->get_customer_id();
//     $email = $order->get_billing_email();
//     $total = $order->get_total();
//     if( !$email || !$total ) return;
//     $data = roadcube_checkout_new_transaction_call($email, $total);
//     update_post_meta($order_id,'roadcube_new_transaction',true);
//     // echo '<pre>';
//     // print_r($data);
//     // echo '</pre>';
// }

add_action('woocommerce_checkout_before_order_review', 'roadcube_woocommerce_callback');
function roadcube_woocommerce_callback()
{
    if (!is_user_logged_in()) return ''; // Return nothing if the user is not logged in
            ob_start(); // Start output buffering
            if( get_current_user_id() ) {
                $user_id = get_current_user_id();
                $user_data = get_userdata( $user_id );
                $user_email = $user_data->user_email;
                $availableCoupon = roadcube_get_user_available_coupons(1, $user_email);

                if (isset($availableCoupon['data']['coupons']) && is_array($availableCoupon['data']['coupons'])) {
                    $count = count($availableCoupon['data']['coupons']);
                } else {
                    $count = 0; // Default to 0 if no coupons or invalid data
                }
                
            }
            ?>
    <div class="parentDiv">
        <button type="button" id="roadcube-show-coupons" style="margin-bottom:16px;">
           <?php 
            $coupon_button_label = Coupon_Claimer::roadcube_get_setting('coupon_button_label');

            if ($coupon_button_label) {
                echo esc_html($coupon_button_label);
            } else {
                echo esc_html__('Apply loyalty coupon', 'roadcube');
            }
         ?>

        </button>
        <?php if($count != 0){ ?>
        <span class="badge"><?php echo $count; ?></span>
        <?php } ?>
    </div>
           
<?php
}
add_action('woocommerce_before_calculate_totals', 'roadcube_apply_the_discount');
function roadcube_apply_the_discount($cart)
{
    if (is_admin() && ! defined('DOING_AJAX')) return;
    $user_id = get_current_user_id();
    if (!$user_id || WC()->cart->get_cart_contents_count() == 0) return;
    $user_claimed_coupon = get_user_meta($user_id, 'roadcube_claimed_coupons', true) ?: [];
    $claimed_coupon = end($user_claimed_coupon);
    if (empty($claimed_coupon) || isset($claimed_coupon['redeemed'])) return;
    $cart_total = 0;
    foreach ($cart->get_cart() as $cart_item_key => $cart_item) {
        $cart_total += floatval($cart_item['line_total']);
    }

    $cost = floatval($claimed_coupon['cost']);
    $cost_type = $claimed_coupon['cost_type'];

    if (!empty($cost_type) && $cost_type == 'percentage') {
        $amount = $cart_total * (float)$cost / 100;
        $cart->add_fee('Discount', -1 * $amount);
    } else {
        $cart->add_fee('Discount', -1 * (float)$cost);
    }
}
add_action('woocommerce_thankyou', 'roadcube_add_the_user_coupon_redeemed');
function roadcube_add_the_user_coupon_redeemed($order_id)
{
    $user_id = get_current_user_id();
    if (!$user_id) return;
    $user_claimed_coupon = get_user_meta($user_id, 'roadcube_claimed_coupons', true) ?: [];
    $claimed_coupon = end($user_claimed_coupon);
    $key = key($user_claimed_coupon);
    if ($claimed_coupon && !isset($claimed_coupon['redeemed'])) {
        $claimed_coupon['redeemed'] = true;
        $user_claimed_coupon[$key] = $claimed_coupon;
        update_user_meta($user_id, 'roadcube_claimed_coupons', $user_claimed_coupon);
    }
}
add_action('woocommerce_order_status_changed', 'roadcube_trigger_charge_point', 10, 3);
function roadcube_trigger_charge_point($order_id, $old_status, $new_status)
{
    $charge_status = Coupon_Claimer::roadcube_get_setting('roadcube_charge_point_val');
    // file_put_contents('cmodrlogs.txt', $charge_status . " Charge Status " . PHP_EOL, FILE_APPEND | LOCK_EX);
    // file_put_contents('cmodrlogs.txt', $new_status . " New Status " . PHP_EOL, FILE_APPEND | LOCK_EX);
    if (!empty($charge_status) && is_string($charge_status)) {
        $charge_status_array = explode(',', $charge_status);
        if (!in_array($new_status, $charge_status_array)) return;
    } else {
        return;
    }
    $order = wc_get_order($order_id);
    $customer_id = $order->get_customer_id();
    $email = $order->get_billing_email();
    $phone = $order->get_billing_phone();
    $total = $order->get_total();
    if (!$email || !$total) return;
    // file_put_contents('cmodrlogs.txt', "Called" . PHP_EOL, FILE_APPEND | LOCK_EX);
    $data = roadcube_checkout_new_transaction_call($email, $total, $order_id, $phone);
    // get the API log
    $log = get_option('roadcube_log') ?: [];
    $log[] = $data;
    update_option('roadcube_log', $log);
    // get the API log
    if (isset($data['status']) && $data['status'] == 'success') {
        $trans_id = $data['data']['transaction_id'];
        update_post_meta($order_id, 'roadcube_point_trans_id', $trans_id);
    }
}
add_action('woocommerce_order_status_changed', 'roadcube_trigger_refund_point', 10, 3);
function roadcube_trigger_refund_point($order_id, $old_status, $new_status)
{
    $refund_status = Coupon_Claimer::roadcube_get_setting('roadcube_refund_point_val');
    if (!empty($refund_status) && is_string($refund_status)) {
        $refund_status_array = explode(',', $refund_status);
        if (!in_array($new_status, $refund_status_array)) return;
    } else {
        return;
    }
    // $order = wc_get_order( $order_id );
    // $customer_id = $order->get_customer_id();
    // $email = $order->get_billing_email();
    // $total = $order->get_total );
    // if( !$email || !$total ) return;
    $trans_id = get_post_meta($order_id, 'roadcube_point_trans_id', true);
    $data = roadcube_checkout_cancel_transaction_call($trans_id);
    // get the API log
    $log = get_option('roadcube_log') ?: [];
    $log[] = $data;
    update_option('roadcube_log', $log);
}
add_action('woocommerce_after_shop_loop_item_title', 'roadcube_new_badge_shop_page', 3);
function roadcube_new_badge_shop_page()
{
    if (!Coupon_Claimer::roadcube_get_setting('roadcube_enable_point')) return;
    global $product;
    $product_id = $product->get_id();
    $product_data = get_post_meta($product_id, 'roadcube_product_created_data', true);
    if (isset($product_data['status']) && $product_data['status'] == 'success') {
        $price = floor(floatval($product->get_price()));
        $points = intval($product_data['data']['product']['reward_points']);
        $actual_point =  Coupon_Claimer::roadcube_get_setting('roadcube_point_mul_price') ? $price * $points : $points;
        echo '<span class="onsale" style="background: white;font-weight:600;">+' . esc_attr($actual_point)  . ' ' . esc_html__(' Πόντοι', 'roadcube') . '</span>';
    } else {
        $point = 1;
        $price = floor(floatval($product->get_price()));

        $actual_point =  Coupon_Claimer::roadcube_get_setting('roadcube_point_mul_price') ? $price * intval($point) : intval($point);
        echo '<span class="onsale" style="background: white;font-weight:600;">+' . esc_attr($actual_point)  . ' ' . esc_html__(' Πόντοι', 'roadcube') . '</span>';
    }
}

add_action('woocommerce_single_product_summary', 'roadcube_new_reward_point');
function roadcube_new_reward_point()
{
    if (!Coupon_Claimer::roadcube_get_setting('roadcube_enable_point')) return;
    global $product;
    $product_id = $product->get_id();
    $product_data = get_post_meta($product_id, 'roadcube_product_created_data', true);
    if (isset($product_data['status']) && $product_data['status'] == 'success') {
        $price = floor(floatval($product->get_price()));
        $points = intval($product_data['data']['product']['reward_points']);
        $actual_point =  Coupon_Claimer::roadcube_get_setting('roadcube_point_mul_price') ? $price * $points : $points;
        echo '<span class="onsale" style="background: white;font-weight:600;">+' . esc_attr($actual_point)  . ' ' . esc_html__(' Πόντοι', 'roadcube') . '</span>';
    } else {
        $point = 1;
        $price = floor(floatval($product->get_price()));

        $actual_point =  Coupon_Claimer::roadcube_get_setting('roadcube_point_mul_price') ? $price * intval($point) : intval($point);
        echo '<span class="onsale" style="background: white;font-weight:600;">+' . esc_attr($actual_point)  . ' ' . esc_html__(' Πόντοι', 'roadcube') . '</span>';
    }
}
