<?php
/**
 * 
 * Plugin Name: RoadCube
 * Description: Provides loyalty benefits to the customers of RoadCube members
 * Tags: roadcube, woocommerce, loyalty, rewards
 * Version: 1.0.10
 * Requires at least: 5.2
 * Tested up to: 6.7.1
 * Stable tag: 1.0.9
 * License: GPLv2 or later
 * Requires at least: 5.2
 * Requires PHP: 7.2
 * Tested up to: 6.4.1
 * WC tested up to: 8.2.2
 * License: GPL v2 or later
 * License URI: https://www.gnu.org/licenses/gpl-2.0.html
 * Text Domain: roadcube
 * Author: Dimitris Kalavasis
 * Author URI: https://roadcube.com/
 * 
 */

if(!defined('ABSPATH')){
    exit;
}
if( !class_exists( 'Coupon_Claimer') ) {
    class Coupon_Claimer{
        static protected $instance = NULL;
        static function get_instance(){
            if( self::$instance == NULL ) {
                self::$instance == new self();
            }
            return self::$instance;
        }
        function __construct(){
            $this->consts();
            $this->includes();
            // registration shortcode
            add_shortcode('roadcube_register',[$this,'roadcube_register_callback']);
            // enqueue
            add_action('wp_enqueue_scripts',[$this,'roadcube_enqueue']);
            // admin enqueue
            add_action('admin_enqueue_scripts',[$this,'roadcube_admin_enqueue']);
            // settings
            add_action('admin_menu',[$this,'roadcube_settings']);
            // user form shortcode
            add_shortcode('roadcube_user_register_form',[$this,'roadcube_user_register_form']);
            // existing user form shortcode
            add_shortcode('roadcube_existing_user_register_form',[$this,'roadcube_existing_user_register_form']);
            // get user point shortcode
            add_shortcode('roadcube_get_user_points',[$this,'roadcube_get_user_points_callback']);
            // get user show gifts
            add_shortcode('roadcube_show_gifts',[$this,'roadcube_show_gifts_callback']);
            // get user show gifts
            add_shortcode('roadcube_user_login',[$this,'roadcube_user_login_callback']);
            add_shortcode('roadcube_loyalty_coupon_button',[$this,'roadcube_loyalty_coupon_button_callback']);

        }
        function roadcube_loyalty_coupon_button_callback() {
            if (!is_user_logged_in()) return ''; // Return nothing if the user is not logged in
            ob_start(); // Start output buffering
            if( get_current_user_id() ) {
                $user_id = get_current_user_id();
                $user_data = get_userdata( $user_id );
                $user_email = $user_data->user_email;
                $availableCoupon = roadcube_get_user_available_coupons(1, $user_email);

                if (isset($availableCoupon['data']['coupons']) && is_array($availableCoupon['data']['coupons'])) {
                    $count = count($availableCoupon['data']['coupons']);
                } else {
                    $count = 0; // Default to 0 if no coupons or invalid data
                }
                
            }
            ?>
            <div class="parentDiv">
                <button type="button" id="roadcube-show-coupons" style="margin-bottom:16px;">
                <?php 
                        $coupon_button_label = Coupon_Claimer::roadcube_get_setting('coupon_button_label');

                        if ($coupon_button_label) {
                            echo esc_html($coupon_button_label);
                        } else {
                            echo esc_html__('Apply loyalty coupon', 'roadcube');
                        }
                    ?>               
                </button>

                <?php if($count != 0){ ?>
                <span class="badge"><?php echo $count; ?></span>
                <?php } ?>                
            </div>
            <?php
            return ob_get_clean(); // Return the output
        }
        function roadcube_show_gifts_callback(){
            ob_start();
            include(ROADCUBE_PATH.'templates/show_gifts.php');
            return ob_get_clean();
        }
        function roadcube_admin_enqueue(){
            $version = wp_rand(1,9).'.'.wp_rand(0,9);
            wp_enqueue_style( 'roaddcube_select2', ROADCUBE_URL.'assets/css/select2.min.css' );
            wp_enqueue_script( 'jquery' );
            // enqueue swal
            wp_enqueue_script('roadcube_swal2', ROADCUBE_URL.'assets/js/sweetalert.js');
            wp_enqueue_script('roadcube_select2_script', ROADCUBE_URL.'assets/js/select2.min.js');
            wp_enqueue_script('roadcube_script', ROADCUBE_URL.'assets/js/script.js',array(), $version);
            // localize ajax
            wp_enqueue_script('roadcube_localize', ROADCUBE_URL.'assets/js/localize.js');
            $localize_data =  array(
                'ajax_url' => admin_url('admin-ajax.php'),
                'login_url' => Coupon_Claimer::roadcube_get_setting('login_page') ?: wp_login_url()
            );
            wp_localize_script('roadcube_localize','roadcube',$localize_data);
        }
        function roadcube_enqueue(){
            $version = wp_rand(1,9).'.'.wp_rand(0,9);
            // css
            wp_enqueue_style('roadcube_style', ROADCUBE_URL.'assets/css/style.css');
            wp_enqueue_style( 'roadcube-font-awesome', ROADCUBE_URL.'assets/css/all.min.css' );
            // js
            wp_enqueue_script('jquery');
            wp_enqueue_script('roadcube_swal2', ROADCUBE_URL.'assets/js/sweetalert.js');
            wp_enqueue_script('roadcube_script', ROADCUBE_URL.'assets/js/script.js',array(), $version);
            wp_enqueue_script('roadcube_coupon_manager_script', ROADCUBE_URL.'assets/js/coupon_manager.js',array(), $version);
            wp_localize_script('roadcube_coupon_manager_script', 'roadcubeData', array(
                'title' => Coupon_Claimer::roadcube_get_setting('coupon_button_title'),
                'close_label' => Coupon_Claimer::roadcube_get_setting('coupon_button_close_label'),
            ));
            wp_enqueue_script('roadcube_localize', ROADCUBE_URL.'assets/js/localize.js');
            $localize_data =  array(
                'ajax_url' => admin_url('admin-ajax.php'),
                'login_url' => Coupon_Claimer::roadcube_get_setting('login_page') ?: wp_login_url()
            );
            if( get_current_user_id() ) {
                $user_id = get_current_user_id();
                $user_data = get_userdata( $user_id );
                $user_email = $user_data->user_email;
                $user_mobile = get_user_meta( $user_id, 'roadcube_mobile', true );
                $user_mobile = $user_data->user_email;
                if( $user_mobile) {
                    $localize_data['user_mobile'] = $user_mobile;
                }
                $localize_data['coupon_data'] = roadcube_get_user_available_coupons( 1, $user_email );
            }
            wp_localize_script('roadcube_localize', 'roadcube', $localize_data);
        }
        function roadcube_user_register_form(){
            ob_start();
            include(ROADCUBE_PATH.'templates/register-template.php');
            return ob_get_clean();
        }
        function roadcube_existing_user_register_form(){
            ob_start();
            include(ROADCUBE_PATH.'templates/register-to-server-template.php');
            return ob_get_clean();
        }
        function roadcube_settings(){
            add_menu_page(
                __('RoadCube','roadcube'),
                __('RoadCube','roadcube'),
                'manage_options',
                'roadcube_settings',
                [$this,'roadcube_settings_callback']
            );
        }
        static function roadcube_get_setting( $name ) {
            $settings = get_option('roadcube_settings');
            if( $settings && is_array($settings) && array_key_exists($name,$settings) ) {
                return $settings[$name];
            }
            return false;
        }
        function roadcube_settings_callback(){
            include(ROADCUBE_PATH.'core/settings.php');
        }
        function consts(){
            define('ROADCUBE_PATH',plugin_dir_path(__FILE__));
            define('ROADCUBE_URL',plugin_dir_url(__FILE__));
        }
        function includes(){
            include(ROADCUBE_PATH.'core/api.php');
            include(ROADCUBE_PATH.'core/ajax_handle.php');
            include(ROADCUBE_PATH.'core/user_meta_field.php');
            include(ROADCUBE_PATH.'roadcube-transaction-list/index.php');
            include(ROADCUBE_PATH.'core/woocommerce.php');
            include(ROADCUBE_PATH.'core/create_product.php');
            include(ROADCUBE_PATH.'core/ga4.php');
        }
        function activate(){
            flush_rewrite_rules();
        }
        function roadcube_user_login_callback(){
            ob_start();
            include(ROADCUBE_PATH.'templates/login_ui.php');
            return ob_get_clean();
        }
        function roadcube_get_user_points_callback(){
            ob_start();
            include(ROADCUBE_PATH.'templates/get_user_points.php');
            return ob_get_clean();
        }
        function roadcube_register_callback(){
            ob_start();
            include(ROADCUBE_PATH.'templates/register-template.php');
            return ob_get_clean();
        }
    }
    Coupon_Claimer::get_instance();
}
add_action( 'login_init', 'myplugin_add_login_fields' );
 
function myplugin_add_login_fields() {
    $user_name = isset($_POST['log']) ? $_POST['log'] : false;
    $cache_key = 'rc_login_user_name';
    wp_cache_set( $cache_key, $user_name );
    $user_name = wp_cache_get( $cache_key );
    if( !$user_name ) return;
    global $wpdb;
    $table = $wpdb->prefix.'usermeta';
    $results = $wpdb->get_results($wpdb->prepare("SELECT * FROM $wpdb->usermeta WHERE meta_value=%s", $user_name),ARRAY_A);
    if( count($results) > 0 ) {
        $user_id = $results[0]['user_id'];
        $user_data = get_userdata( $user_id );
        $_POST['user_login'] = $user_data->user_login;
    }
}
register_activation_hook(__FILE__, 'roadcube_sync_all_prev_users');
function roadcube_sync_all_prev_users(){
    $users = get_users();
    if( empty($users) ) return;
    $emails = [];
    $i = 1;
    foreach($users as $user){
        $emails[] = $user->user_email;
    }
    $i = 1;
    foreach(array_chunk($emails,10) as $email_chunk) {
        wp_schedule_single_event(time() + 100 * $i, 'roadcube_synce_users', array( $email_chunk ) );
        $i++;
    }
}
add_action('roadcube_synce_users','roadcube_synce_users_callback');
function roadcube_synce_users_callback( $emails ){
    foreach($emails as $email){
        $user_sync_log = [];
        $user_sync_log[] = roadcube_create_user_by_email($email);
        update_option('roadcube_user_sync_log',$user_sync_log);
    }
}