<?php

if(!defined('ABSPATH')){
    exit;
}

$show = true;
$user_id = get_current_user_id();
if( !$user_id ) {
//   echo __('Login first to see the available coupons','roadcube');
//   return false;
    $show = false;
}
$user_mobile = get_user_meta($user_id, 'roadcube_mobile', true);
if( !$user_mobile ) {
    // echo 'User mobile number is not set.';
    // return false;
    $show = false;
}
$data = roadcube_get_available_coupons();
if( isset($data['status']) && $data['status'] == "error" ) {
    if( isset($data['message']) ) {
        echo esc_attr($data['message']);
    } else {
        esc_attr_e('Unknown error occured','roadcube');
    }
    return false;
}
?>
<div class="roadcube-show-gifts-container">
    <div class="roadcube-gifts-holder">
        <?php if(!empty($data['data']['coupons'])){ ?>
            <?php foreach($data['data']['coupons'] as $coupon){ ?>
                <div class="roadcube-gift">
                    <div class="coupon-image">
                        <img src="<?php echo esc_attr($coupon['image']); ?>" alt="coupon image">
                    </div>
                    <div class="coupon-details">
                        <h2><?php echo esc_attr($coupon['title']); ?></h2>
                        <p><?php echo esc_attr(printf('Points: %s',esc_attr($coupon['points']))); ?></p>
                        <!-- <p><?php #printf('Product code: %s',esc_attr($coupon['product_code'])); ?></p> -->
                        <p><?php echo esc_attr($coupon['description']); ?></p>
                        <?php if($show){ ?>
                        <button data-coupon-id="<?php echo esc_attr($coupon['coupon_id']); ?>" class="roadcube-claim-coupon"><?php esc_html_e('Get it','roadcube'); ?></button>
                        <?php } ?>
                    </div>
                </div>
            <?php } ?>
        <?php } else {
            esc_html_e('No coupon found.','roadcube');
        } ?>
    </div>
    <div class="roadcube-pagination">
        <?php
        if( $data['data']['pagination']['next_page'] ) {
            echo esc_attr(printf('<button id="roadcube_next">%s</button>',__('Next','roadcube')));
        }
        if( $data['data']['pagination']['previous_page'] ) {
            echo esc_attr(printf('<button id="roadcube_prev">%s</button>',__('Previous','roadcube')));
        }
        ?>
    </div>
</div>